<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php 
   include_once("security_check.php") ; 

$channel_id = array() ;
$epgPID = 0 ;
$icecachefiles = array() ;
$icefilecount = 0 ;

//echo "$start_time | $end_time <br>\n" ;
 
if($ftp=ftp_connect($ftp_server,$ftp_port))
{
 ftp_login($ftp,$user_name,$user_pw);
 ftp_chdir($ftp,$epg_ice_loc) ;
 ftp_get($ftp,$local_files.DIRECTORY_SEPARATOR."map.ini",$epg_ice_loc."/map.ini",FTP_ASCII) ;
 $sections = parse_ini_file($local_files.DIRECTORY_SEPARATOR."map.ini",true) ;
 foreach($sections as $sectionname => $section)
 {
  if(substr_count($sectionname,"Channel")>0) { $channel_id[$section["channel_id"]]=$section["name"] ; }
  if(substr_count($sectionname,"Map")>0)     { $lcn[$section["lcn"]]=$section["channel_id"] ; }
 }
 
 //print_r($channel_id) ;
 foreach($channel_id as $id => $name)
 {
  if(array_key_exists($name,$ice_chn_trans)) { $channel_id[$id] = $ice_chn_trans[$name] ; }
 }
 //print_r($channel_id) ;
 
 $files = ftp_nlist($ftp,"");
 foreach ($files as $filename)
 {
  //echo $filename."<br>\n" ;
  if(substr_count($filename,"EPG_CACHE") > 0)
	{
	 if(substr($filename,0,8)<>substr($start_time,0,8) and substr($filename,0,8)<>substr($end_time,0,8)) { continue ; }
	 $icefilecount++ ;
	 ftp_get($ftp, $local_files.DIRECTORY_SEPARATOR."EPG_CACHE_$icefilecount", $epg_ice_loc."/".$filename, FTP_ASCII) ;
	 $icecachefiles[$icefilecount] = $local_files.DIRECTORY_SEPARATOR."EPG_CACHE_$icefilecount" ;
	 echo "<!-- ICE Found $filename => EPG_CACHE_$icefilecount -->\n" ;
	}
	else
	{
	 //echo "No match<br>\n" ;
	}
 }
 //unlink($local_files.DIRECTORY_SEPARATOR."EPG_CACHE") ;
 ftp_quit($ftp) ;
}
else
{
 echo "<!-- ICE cannot connect to $ftp_server -->\n" ;
}
 
//
//
//
//
//
//
 
function read_epg_cache($files)
{
 global $channels, $channel_id, $chn_hide, $epgPID, $ice_offset_seconds, $start_time, $end_time ;
 
 $found_data = false ;
 //print_r($files) ;
	
 foreach ($files as $filename)
 {
  echo "<!-- ICE Read $filename -->\n" ;
  if ( !($rows = file($filename)) ) { continue ; }
  echo "<!-- ICE Read ".count($rows)." rows -->\n" ;
	$found_data = true ;
	foreach($rows as $row)
	{
	 list($start,$channel,$duration,$title,$rating,$subtitle,$desc)=explode("|",$row) ;
	 $temp = array() ;
	 $epgPID += 1 ;
	 $temp["epgPID"] = $epgPID ;
	 $temp["epgTitle"] = $title ;
	 $temp["epgSubTitle"] = $subtitle ;
	 $temp["epgChannel"] = $channel_id[$channel] ;
	 $temp["epgDuration"] = $duration ;
	 $temp["epgDescription"] = $desc ;
   $start_timestamp = strtotime(substr($start,4,2)."/".substr($start,6,2)."/".substr($start,0,4)." ".substr($start,8,2).":".substr($start,10,2))+$ice_offset_seconds ;
	 $stop_timestamp = $start_timestamp + ($duration*60) ;
	 $temp["epgStart"] = date("YmdHi",$start_timestamp) ;
	 $temp["epgStop"] = date("YmdHi",$stop_timestamp) ;
	 $temp["epgRepeat"] = false ;
	 
	 //echo $title." from ".$temp["epgStart"]." to ".$temp["epgStop"]." * ".substr($start,4,2)."/".substr($start,6,2)."/".substr($start,0,4)." ".substr($start,8,2).":".substr($start,10,2)."<br>\n" ;
	 
	 $s1 = $start_time ;
	 $s2 = substr($temp["epgStart"],0,12) ;
	 $e1 = $end_time ;
	 $e2 = substr($temp["epgStop"],0,12) ;
	 
	 $ss = (strcmp($s1,$s2)<0) && (strcmp($s2,$e1)<0) ;
	 $ee = (strcmp($s1,$e2)<0) && (strcmp($e2,$e1)<0) ;
			 
	 //echo "s=$s2=$ss e=$e2=$ee or=".($ss or $ee)."<br>\n" ;
	 if(!array_key_exists($temp["epgChannel"],$chn_hide)) { $chn_hide[$temp["epgChannel"]] = true ; }
	 if(($ss or $ee) and !$chn_hide[$temp["epgChannel"]] and ($temp["epgDuration"]>=$GLOBALS["minimum_duration"]))
	 {		
	  //echo "ok s=$s2=$ss e=$e2=$ee or=".($ss or $ee)." $s2 $e2<br>\n" ;
	  $programmes[$temp["epgPID"]]=$temp;
	  $channels[$temp['epgChannel']] = true ;
		//echo $temp["epgChannel"]."=".$title."<br>\n" ;
	 }
	}
 }
 //print_r($programmes) ;
 //echo "<!-- ICE Read source => ".count($programmes)." entries found -->\n" ;
 if ($found_data) { return $programmes ; }
 //if ($found_data) { return ($programmes) ; }
 //echo "<!-- ICE Read source => Source load failed -->\n";
 return false ;
}
 
 function parsefile()
 {
  global $icecachefiles ;
	
	echo "<!-- ICE parsing source -->\n" ;
	$result = read_epg_cache($icecachefiles) ;
  return $result ;
 }
 

?>
