<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

* Redistributions must retain the above copyright
notice, this list of conditions and the following disclaimer.

* The name of John Stevens may not
be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php
include_once ("security_check.php");

$channel_id = array();
$epgPID = 0;
echo "<!-- MEI starting -->\n";

add_diag("MEI search     today=$start_time");
echo "<!-- MEI search     today=$start_time -->\n";

// MEI files are large, so only retrieve if the local cache is too old.
// FIXME: Might make sense to split the MEI file into per-day files
if ($mei_servername == "Local")
{
  $meicachefile = $mei_folder . DIRECTORY_SEPARATOR . $epg_mei_identifier;
  add_diag("MEI Local cachefile=$meicachefile");
  echo "<!-- MEI Local cachefile=$meicachefile -->\n";
} else // then it must be ftp

{
  $meicachefile = $local_files . DIRECTORY_SEPARATOR . "EPG_CACHE";
  add_diag("MEI $ftp_server to cachefile=$meicachefile");
  echo "<!-- MEI $ftp_server to cachefile=$meicachefile -->\n";
  if (!file_exists($meicachefile) or abs(filemtime($meicachefile) - time()) >= $epg_mei_cachetime * 60)
  {
    $tmpfile = $meicachefile . "." . getmypid();
    if ($ftp = ftp_connect($ftp_server, $ftp_port))
    {
      ftp_login($ftp, $user_name, $user_pw);
      ftp_chdir($ftp, $epg_mei_loc);
      $x = ftp_get($ftp, $tmpfile, $epg_mei_loc . "/" . $epg_mei_identifier, FTP_ASCII);
      echo "<!-- MEI FTPget ($x) $epg_mei_loc/$epg_mei_identifier -->\n";
      ftp_quit($ftp);
      if (file_exists($tmpfile) and filesize($tmpfile) > 0)
      {
        if (DIRECTORY_SEPARATOR == "\\")
        {
          unlink($meicachefile);
        }
        rename($tmpfile, $meicachefile);
      }
    } else
    {
      echo "<!-- MEI cannot connect to $ftp_server -->\n";
    }
  }
}

// end of inline preliminary code
//
//
// start of functions


function read_epg_cache($filename)
{
  global $channels, $channel_id, $chn_hide, $epgPID, $ice_offset_seconds, $start_time, $end_time, $lcn_chn_trans;


  if (!($rows = file($filename)))
  {
    return false;
  }
  add_diag("MEI finished reading $filename(" . count($rows) . " entries)");
  echo "<!-- MEI finished reading $filename(" . count($rows) . " entries) -->\n";
  foreach ($rows as $row)
  {
    list($cnt, $start_timestamp, $stop_timestamp, $lcn, $title, $subtitle, $repeat, $new, $prod_date, $premiere,
      $last_chance, $desc, $category, $duration, $aspect, $colour, $subtitles, $episode_num, $episode_system,
      $rating_system, $rating, $star_rating) = explode("|", $row);
    //add_diag("MEI $start_timestamp,$stop_timestamp,$lcn,$title,$subtitle,$category") ;
    $temp = array();
    $epgPID += 1;
    $temp["epgPID"] = $epgPID;
    $temp["epgTitle"] = $title;
    $temp["epgSubTitle"] = $subtitle;
    $channel = $lcn_chn_trans[$lcn];
    if (!isset($channel))
    {
      continue;
    }
    $temp["epgChannel"] = $channel;
    $temp["epgDuration"] = $duration;
    $temp["epgDescription"] = $desc;
    $temp["epgStart"] = $start_timestamp;
    $temp["epgStop"] = $stop_timestamp;
    $temp["epgRepeat"] = strtolower(substr($repeat, 0, 1)) == "y"; // ?

    //add_diag("MEI read $title from ".$temp["epgStart"]." to ".$temp["epgStop"]." * ".substr($start,4,2)."/".substr($start,6,2)."/".substr($start,0,4)." ".substr($start,8,2).":".substr($start,10,2) ) ;
    //add_diag("MEI read $title from ".$temp["epgStart"]." to ".$temp["epgStop"]." * ".str_replace("-","/",$start) ) ;

    $s1 = $start_time;
    $s2 = substr($temp["epgStart"], 0, 12);
    $e1 = $end_time;
    $e2 = substr($temp["epgStop"], 0, 12);

    $ss = (strcmp($s1, $s2) < 0) && (strcmp($s2, $e1) < 0);
    $ee = (strcmp($s1, $e2) < 0) && (strcmp($e2, $e1) < 0);

    //echo "s1=$s1 s2=$s2 e1=$e1 e2=$e2 ss=$ss ee=$ee or=".($ss or $ee)."<br>\n" ;
    if (!array_key_exists($temp["epgChannel"], $chn_hide))
    {
      echo "<!-- MEI hiding undefined channel " . $temp["epgChannel"] . " -->\n";
      $chn_hide[$temp["epgChannel"]] = true;
    }
    if (($ss or $ee) and !$chn_hide[$temp["epgChannel"]] and ($temp["epgDuration"] >= $GLOBALS["minimum_duration"]))
    {
      //echo "ok s=$s2=$ss e=$e2=$ee or=".($ss or $ee)." $s2 $e2<br>\n" ;
      $programmes[$temp["epgPID"]] = $temp;
      $channels[$temp['epgChannel']] = true;
      //echo $temp["epgChannel"]."=".$title."<br>\n" ;
    }
  }
  echo "<!-- MEI found " . count($programmes) . " programme entries -->\n";
  return $programmes;
}

function parsefile()
{
  global $meicachefile;

  $programmes = read_epg_cache($meicachefile);
  return $programmes;
}


?>
